package Plugins::uploading;

use strict;
use warnings;
use lib '..';
use Plugin;                                                                                                                                                                      
use base 'Plugin'; 
use HTTP::Request::Common qw(POST GET);
use vars qw($VERSION);
$VERSION = "1.6" ;


our $options ={
		plugin_id => 1004,
		plugin_prefix=>'up',
		domain=>'uploading.com',
		name=>'uploading',
		required_login=>1,
		can_login => 1,
		upload=>1,
		download=>1,
};

sub max_filesize {
	my $self = shift;
	my $a = 1000;
	$a = 2000 if($self->{logged});
	$a = 10000 if($self->{logged} && $self->{premium});
	return $a*1024*1024;
}

sub is_broken {
	my $self = shift;
	my $link = shift;
	$self->get($link);
	return 1 if($self->{content} =~ /The requested file is not found/);
	return 0;
}

sub check_link {
	shift;
	my $link = shift;
	if ($link =~ /uploading\.com/) {
		return 1;
	}
	return 0;
}

sub login {
	my $self = shift;
	my $a = shift;
	$self->{action} = 'login';
	$self->get('http://uploading.com/');
	my $req = POST "http://uploading.com/general/login_form/?JsHttpRequest=".time.'-xml',
	        Referer => 'http://uploading.com/',
       	Content => [email=>$a->{login}, password=>$a->{password}];
	$self->request($req);
	if(($self->{response}->is_success) || ($self->{response}->code == 302)) {
		return 0 if($self->{content} =~ /  email  /);
		return 0 if($self->{content} =~ /Введен неправильный email или пароль/);
		return 0 if($self->{content} =~ /captcha/);
		$self->get('http://uploading.com/');
		$self->{logged} = 1;
		$self->{premium} = 1 if($self->{content} =~ /Membership: Premium/);
		return 1;

	} else {
		return 0;
	}
}

sub upload_file {
	my $self = shift;
	my $file = shift;
	my $filename = shift;
	my $description = shift;
	$self->{action} = 'upload';
	my $r = $self->get('http://uploading.com/');
	if($self->{content} =~ /Sorry, but you have reached your account space limit/) {
		return {error=>5, errortext=>'Account space limit reached'};
	}
	if($self->{content} =~ /Service Not Available/s || $self->{content} =~ /there are no free servers available/s) {
		return {error=>5, errortext=>'Service Not Available'};
	}
	if(($r->is_success)) {
		unless ($self->{content} =~ /upload_url: [\"\']([^\"\']+)/) {
			return {error=>1, errortext=>'Cannot upload'};
		}
		my $upload_id = $1;
		my $upload_link = $1;
		$self->{content} =~ /'?SID'?: [\"\']([^\"\']+)/;
		my $sid = $1;
		$upload_link =~ s~\\~~g;
		$upload_link =~ s~\%([0-9A-F]{2})~chr(hex($1))~ge;
		$browser->agent('Shockwave Flash');
		my $done_link = 'http://uploading.com/files/generate/?ajax';
		my $req = POST $done_link, 
			Accept=> 'application/json, text/javascript, */*; q=0.01',
			Referer=>'http://uploading.com/',
			'X-Requested-With'=>'XMLHttpRequest',
			Content=>[name=>$filename, size=>-s "$c->{filesdir}/$file"];
		$self->request($req);
		$self->{content} =~ /"link":"([^\"]+)"/;
		my $link = $1;
		$self->{content} =~ /file_id":"?([^\"]+)\"?/;
		my $file_id = $1;
		$req = POST $upload_link,
			Content_Type => "multipart/form-data",
			Content => [Filename=>"$filename", file=>$file_id, folder_id=>0, SID=>$sid, file=>["$c->{filesdir}/$file", $filename], Upload=>'Submit Query'];
		$self->up_file($req);
		$self->{content} =~ m~:\"([^\"]+)~;
			
		unless($link) {
			return {error=>1, errortext=>'Cannot upload'};
		}
		$link =~ s~\\~~g;
		$self->get($link);
		return {download=>$link, remove=>''};
		
	}
	
}

sub download {
	my $self = shift;
	my $url = shift;
	my $prefix = shift;
	my $update_stat = shift;
	my $req;
	my $response;
	my $dlink = '';
	$self->{action} = 'download';
	$req = GET $url;
	my $ff = $self->direct_download($req, $url, $prefix, $update_stat);
	if($ff->{type} =~ /html/) {
		$self->request($req);
		my $code;	
#	$res->content =~ m#action: 'get_link',[\n\s]*code: "(.*?)"#si;
#	my $code = $1;
		if($self->{content} =~ m~action: 'get_link',[\n\s]*code: "(.*?)"~) {
			$code = $1;
		}
		unless($code) {
			$log->write(2, 'free download');
			my $h = HTML::TreeBuilder->new_from_content($self->{content});
			$h->ignore_unknown(0);
			$h = $h->elementify();
			my $form = $h->look_down('_tag', 'form', 'id', 'downloadform');
			my $action = $form->{action};
			my @inputs = $form->look_down('_tag', 'input');
			my %pcontent = map {$_->{name}=>$_->{value}} grep {$_->{name}}@inputs;
			my $req = POST $form->{action},
		        	Referer => $url,
	        		Content => [action=>'second_page', file_id=>$pcontent{file_id}, code=>$pcontent{code}, LMI_PAYEE_PURSE=>$pcontent{LMI_PAYEE_PURSE},LMI_PAYMENT_AMOUNT=>$pcontent{LMI_PAYMENT_AMOUNT},
					LMI_PAYMENT_DESC=>$pcontent{LMI_PAYMENT_DESC},LMI_SIM_MODE=>$pcontent{LMI_SIM_MODE}, user_id=>$pcontent{user_id}, proceed_without_registration=>'on'];
#LMI_PAYEE_PURSEZ207579698656LMI_PAYMENT_AMOUNT#amount#LMI_PAYMENT_DESCUploading.com Premuim MembershipLMI_SIM_MODE0actionsecond_pagecode3ab5fm5efile_id44819574
#				proceed_without_registrat...onuser_id#user_id#
			$url = $form->{action};	
			$self->request($req);
			$self->{content} =~ /app.cookie.set\(\'f\',\s*\'([^\']*)/s;
			my $fff = $1;
			$log->write(2,'f:'.$fff);
			my $cj = $browser->cookie_jar();
			$cj->set_cookie(2,'f', $fff,'/', 'uploading.com');
			$h = $h->delete();		
			$self->{content} =~ m~code: "([\da-z]+)"~;
			$code = $1;
			$log->write(2, "sleep 60 seconds");
			sleep(60);
		}
		$log->write(2, "code: $code");
		$req = POST 'http://uploading.com/files/get/?ajax',
		        	Referer => $url,
				Content_Type => "application/octet-stream",
				'X-Requested-With'=>'XMLHttpRequest',
	        		Content => [action=>'get_link', code=>$code, pass=>'undefined'];
		$self->request($req);
		$log->write(2, $req->as_string());
		$self->{content} =~ /link\":\"([^\"]+)/;
		$dlink = $1;
		$dlink =~ s~\\~~g;
		$log->write(2, "dlink: $dlink");
		$req = GET $dlink, Referer=>$url;
		my $ff = $self->direct_download($req, $dlink, $prefix, $update_stat);
		if($ff->{type} =~ /html/) {
			return {error=>-2, error_text=>'Cannot download direct link'};
		}
	}
	return {error=>0, filename=>$ff->{filename}, filesize=>$ff->{filesize}};

}

1;
