package Plugins::ziddu;

use strict;
use warnings;
use lib '..';
use Plugin;                                                                                                                                                                      
use base 'Plugin'; 
use HTTP::Request::Common qw(POST GET);
use Data::Dumper;
use vars qw($VERSION);

$VERSION = "1.6" ;

our $options = {
		plugin_id => 1024,
		plugin_prefix=>'zd',
		domain=>'ziddu.com',
		name=>'ziddu',
		can_login => 1,
		upload=>1,
		download=>1,
};

sub check_link {
	shift;
	my $link = shift;
	if ($link =~ /ziddu\.com/) {
		return 1;
	}
	return 0;
}

sub is_broken {
	my $self = shift;
	my $link = shift;
	$self->get($link);
	return 1 if($self->{content} =~ /this file has been removed/);
	return 0;
}

sub max_filesize {
	return 2048*1024*1024;
}
my $base = 'http://www.ziddu.com';
sub login {
	my $self = shift;
	my $a = shift;
	$self->{action} = 'login';
	my $req = GET 'http://ziddu.com/';
	$self->request($req);
	$base = $self->{response}->base();
	
	$req = POST "${base}/login.html",
	        Referer => "http://ziddu.com/login.html",
	       	Content => [user=>$a->{login}, pass=>$a->{password}, submit=>'Login'];	
	$self->request($req);
	if(($self->{response}->is_success) || ($self->{response}->code == 302)) {
		return 0 if($self->{content} =~ /No user found with such email/);
		return 0 if($self->{content} =~ /Login failed/);
		return 1;
	} else {
		return 0;
	}
}


sub upload_file {
	my $self = shift;
	my $file = shift;
	my $filename = shift;
	my $description = shift;
	$self->{action} = 'upload';
	my $h = $self->getHT('http://uploads.ziddu.com/uploadanon.php');
	if(($self->{response}->is_success)) {
		my ($hostname) = 'ziddu.com';
#		my $progress_id = $self->GRC;;
		my $form = $h->look_down('_tag', 'form', 'name',"form_upload");
		my $action = $form->{action};
		my @inputs = $form->look_down('_tag', 'input');
		
		my %pcontent = map {$_->{name}=>$_->{value}} grep {$_->{name}}@inputs;
		$pcontent{'upfile_0'} = ["$c->{filesdir}/$file", $filename];
		$action = 'http://uploads.ziddu.com/'.$action unless($action =~ m~http://~);
		my $req = POST $action,
	        	Referer => "http://www.ziddu.com/",
			Content_Type => "multipart/form-data",
	        	Content => [%pcontent
				];
		$self->up_file($req);
		unless($self->{content} =~ m~(http://www.ziddu.com/download/[^\"\s]+)~s){ 
			return {error=>1, errortext=>'Cannot upload'};
		}
		my $link = $1;
		my $remove = '';
		return {download=>$link, remove=>$remove};
		
	}
	
}
sub GRC {
	my $self = shift;
	my $length=32;
	my @letters=('a'..'f','k'..'o', 'u','p','q','r', 's','t','v','x','1'..'0');
	my $s = '';
	my $lettersLength = scalar(@letters);
	for(my $i = 0 ; $i < $length ; $i++) {
		$s.= $letters[int rand($lettersLength)];
	}
	return $s;
}
sub download {
	my $self = shift;
	my $url = shift;
	my $prefix = shift;
	my $update_stat = shift;
	my $req;
	my $response;
	my $dlink = '';
	$self->{action} = 'download';
	$req = GET $url;
	my $ff = $self->direct_download($req, $url, $prefix, $update_stat);
	if($ff->{type} =~ /html/) {
		return {error=>-2, error_text=>'Cannot download direct link'};
	}
	return {error=>0, filename=>$ff->{filename}, filesize=>$ff->{filesize}};
	

}

1;
