#!/usr/bin/perl
use strict;
use lib '.';
use XFSConfig;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use File::Path;
use LWP::UserAgent;
use HTTP::Request::Common;
$HTTP::Request::Common::DYNAMIC_FILE_UPLOAD = 1;
use File::Copy;
use Digest::MD5;

die"Error1" unless $ENV{REQUEST_METHOD} eq 'POST';
my ($mua);

my $q = CGI->new();
my $f;
$f->{$_}=$q->param($_) for $q->param;

&PreviewUpload if $f->{op} eq 'preview_upload';
&GetHostInfo if $f->{op} eq 'get_host_info';

return Streams() if $f->{call} && $f->{app} && $f->{name};

sleep(2),Send( "OK:0:ERROR: dl_key is wrong") if $c->{dl_key} && $f->{dl_key} ne $c->{dl_key};

$c->{ffmpeg}||="$c->{cgi_dir}/ffmpeg";


die"Error2" if $c->{user_agent} && $ENV{HTTP_USER_AGENT} ne $c->{user_agent};
die"Error3:$ENV{HTTP_X_REAL_IP}" if $c->{main_server_ip} && $ENV{HTTP_X_REAL_IP}!~/^$c->{main_server_ip}$/;

my $sub={
         del_files      => \&DeleteFiles,
         test           => \&Test,
         test_host      => \&TestHost,
         update_conf    => \&UpdateConfig,
         check_files    => \&CheckFiles,
         check_files_reverse  => \&CheckFilesReverse,
         get_file_stats => \&GetFileStats,
         import_list    => \&ImportList,
         import_list_do => \&ImportListDo,
         torrent_delete => \&TorrentDelete,
         torrent_kill   => \&TorrentKill,
         torrent_status => \&TorrentStatus,
         torrent_done   => \&TorrentDone,
         transfer2      => \&TransferFiles2,
         delete_file_spec => \&DeleteFileSpec,
         gen_snapshots  => \&GenSnapshots,
         rethumb        => \&ReThumb,
         reparse        => \&ReParse,
         rescreen       => \&ReScreen,
         reslide        => \&ReSlide,
         thumb_upload   => \&ThumbUpload,
         add_ftp_users  => \&AddFTPUsers,
         get_video_info => \&GetVideoInfo,
         get_dev        => \&GetDevices,
         move_mode      => \&MoveMode,
         ssd_del_old    => \&SSDDelOld,
         #gen_video_preview => \&GenVideoPreview,
	}->{ $f->{op} };
if($sub)
{
   &$sub;
}
else
{
   die"Error4";
}
exit;


sub DeleteFiles
{
   my $list = $f->{list};
   Send('OK') unless $list;
   &daemonize;
   $|++;
   print"Content-type:text/html\n\n";
   
   my $disk_id = $f->{disk_id};
   print("Invalid disk_id: $disk_id"),exit unless $disk_id=~/^\d+$/;
   my $udir = "$c->{cgi_dir}/uploads/$f->{disk_id}";
   my $idir = "$c->{htdocs_dir}/i/$disk_id";

   for my $x (split(/:/,$list))
   {
      my ($file_id,$file_code)=split('-',$x);
      my $dx = sprintf("%05d",$file_id/$c->{files_per_folder});
      unlink("$udir/$dx/$file_code\_n");
      unlink("$udir/$dx/$file_code\_h");
      unlink("$udir/$dx/$file_code\_l");
      unlink("$udir/$dx/$file_code\_p");
      unlink("$c->{cgi_dir}/orig/$f->{disk_id}/$dx/$file_code")  if -e "$c->{cgi_dir}/orig/$f->{disk_id}/$dx/$file_code";
      unlink <$idir/$dx/$file_code*>;
      print"\n";
   }
   print"OK";
}

sub DeleteFileSpec
{
   print"Content-type:text/html\n\n";
   my $disk_id = $f->{disk_id};
   print("Invalid disk_id: $disk_id"),exit unless $disk_id=~/^\d+$/;
   $f->{file_real} =~ s/\W//g;
   $f->{type} =~ s/\W//g;

   my $dx = sprintf("%05d",$f->{file_real_id}/$c->{files_per_folder});

   if($f->{type})
   {
       unlink("$c->{cgi_dir}/uploads/$f->{disk_id}/$dx/$f->{file_real}_$f->{type}");
   }
   if($f->{original} || $f->{type} eq 'o')
   {
       unlink("$c->{cgi_dir}/orig/$f->{disk_id}/$dx/$f->{file_real}");
   }
   print"OK";
}

sub CheckFiles
{
   my $list = $f->{list};
   Send('OK') unless $list;
   my @arr = split(/:/,$list);
   my @nofiles;
   for my $x (@arr)
   {
      my ($file_id,$file_code)=split('-',$x);
      my $dx = sprintf("%05d",$file_id/$c->{files_per_folder});
      push @nofiles,$file_code unless -f "$c->{cgi_dir}/uploads/$f->{disk_id}/$dx/$file_code\_n";
   }
   Send("OK:".join ',',@nofiles );
}

sub CheckFilesReverse
{
   my $deleted=0;
   $|++;
   $f->{disk_id} =~ s/\D//g;
   print"Content-type:text/html\n\n";
   print"Starting...";
   my $dir = "$c->{cgi_dir}/uploads/$f->{disk_id}";
   opendir(DIR, $dir) || Send("Error:cant open upload_dir");
   foreach my $fn (readdir(DIR))
   {
      next if $fn =~ /^\.{1,2}$/;
      next unless -d "$dir/$fn";
      next unless $fn=~/^\d{5}$/;
      opendir(DIR2, "$dir/$fn")||next;
      my @arr;
      while( defined(my $fn2=readdir(DIR2)) )
      {
         next if $fn2 =~ /^\.{1,2}$/;
         my ($code) = $fn2=~/^(\w{12})_\w$/;
         unlink("$dir/$fn/$fn2"),next unless $code;
         push @arr, $fn2;
      }
      closedir(DIR2);
      my $ua = LWP::UserAgent->new(agent => $c->{user_agent},timeout => 360);
      my $res = postMain({
                             op     => 'check_codes',
                             codes  => join(',',@arr),
                          }
                         );
      Send("Error: fs bad answer: ".$res->content) unless $res->content=~/^OK/;
      my ($bad) = $res->content=~/^OK:(.+?)$/;
      for( split(/\,/,$bad) )
      {
         #next unless /^\w{12}$/;
         unlink("$dir/$fn/$_");
         $deleted++;
      }
      print"+"
   }
   closedir(DIR);
   print"<br>Files removed from disk: $deleted<br><br>";
}

sub AddFTPUsers
{
  my $ftp_dir = '/home/ftp';

  $|++;
  print"Content-type:text/html\n\nOK";
  my $hh;
  $f->{list}=~s/\r//g;
  for( split(/\n/,$f->{list}) )
  {
    my ($login,$pass) = split(/:/,$_);
    $hh->{$login} = $pass;
  }

  opendir(DIR, $ftp_dir) || Send("Error:cant open ftp dir $ftp_dir");
  foreach my $fn (readdir(DIR))
  {
     next if $fn =~ /^\.{1,2}$/;
     next unless -d "$ftp_dir/$fn";
     print"\n";
     rmtree("$ftp_dir/$fn") unless $hh->{$fn};
  }
  closedir DIR;

  open FF, ">$c->{cgi_dir}/logs/ftp.users";
  my $salt = get_salt();
  for my $login ( keys %$hh )
  {
    my $pass = $hh->{$login};
    #unless(-d "$ftp_dir/$login")
    #{
    #   print"\n";
    #   mkdir("$ftp_dir/$login") || Send("ERROR:mkdir $ftp_dir/$login:$!");
    #   chmod 0777, "$ftp_dir/$login";
    #}
    ### 48 = apache user/group
    my $hash = crypt($pass, $salt);
    print FF "$login:$hash:48:48::$ftp_dir/$login:/bin/false\n";
  }

  exit;
}

sub get_salt {
        my $rands = substr(time(),-4);
        my $salt = ('a'..'z')[int(($rands/100)%26)];
        $salt .= ('a'..'z')[int(($rands%100)%26)];
        return($salt);
}

sub GetFileStats
{
   my $size;
   $f->{disk_id} =~ s/\W//g;
   my ($files,$ss) = scanDir("$c->{cgi_dir}/uploads/$f->{disk_id}");
   $size+=$ss;

   my (undef,$ss)  = scanDir("$c->{cgi_dir}/orig/$f->{disk_id}");
   $size+=$ss;

   my (undef,$ss)  = scanDir("$c->{htdocs_dir}/i/$f->{disk_id}");
   $size+=$ss;

   Send("OK:$files:$size");
}

sub scanDir
{
   my ($dir) = @_;
   opendir(DIR, $dir) || Send("Error:cant open dir $dir:$!");
   my ($files,$size)=(0,0);
   while( defined(my $fn=readdir(DIR)) )
   {
      next if $fn=~/^\.{1,2}$/ || !-d "$dir/$fn";

      opendir(DIR2, "$dir/$fn")||next;
      while( defined(my $fn2=readdir(DIR2)) )
      {
         next if $fn2 =~ /^\.{1,2}$/;
         $files++;
         $size += -s "$dir/$fn/$fn2";
      }
      closedir(DIR2);
   }
   return ($files,$size);
}

sub ImportList
{
   opendir(DIR, "$c->{cgi_dir}/ImportFiles") || Send("Error:cant open ImportFiles dir");
   my @arr;
   while( defined(my $fn=readdir(DIR)) )
   {
      next if $fn=~/^\.{1,2}$/;
      next unless -f "$c->{cgi_dir}/ImportFiles/$fn";
      push @arr, $fn.'-'.(-s "$c->{cgi_dir}/ImportFiles/$fn");
   }
   Send("OK:".join(':',@arr));
}

sub ImportListDo
{
   my $usr_id = $f->{usr_id};
   my $pub    = $f->{pub};
   my $import_dir = "$c->{cgi_dir}/ImportFiles";
   opendir(DIR, $import_dir) || Send("Error:cant open ImportFiles dir:$!");
   my $ua = LWP::UserAgent->new(keep_alive => 1,agent => $c->{user_agent},timeout => 180,);
   my $cx=0;
   require XUpload;
   while( defined(my $fn=readdir(DIR)) )
   {
      next if $fn=~/^\.{1,2}$/;
      next unless -f "$import_dir/$fn";
      #next if $f->{stream} && $fn !~ /^$f->{name}-/i; # stream
      my $file = {file_tmp=>"$import_dir/$fn", file_name_orig=>$fn, file_public=>$pub, usr_id=>$usr_id, no_limits=>1};
      $f->{ip}='1.1.1.1';
      # --------------------
      $file = &XUpload::ProcessFile($file,$f) unless $file->{file_status};
      # --------------------
      #logg('streams', "fs:$fn ".$file->{file_status});
      #Send("Error: $file->{file_status}") if $file->{file_status};

      unlink("$import_dir/$fn") if $f->{delete_after};

      $cx++ unless $file->{file_status};
   }
   Send("OK:$cx") unless $f->{call} eq 'publish_done';
}

sub Test
{
   my @tests;
   $f->{disk_id} =~ s/\D//g;
   my $temp_dir = "$c->{cgi_dir}/temp/$f->{disk_id}";
   my $upload_dir = "$c->{cgi_dir}/uploads/$f->{disk_id}";
   my $orig_dir = "$c->{cgi_dir}/orig/$f->{disk_id}";
   my $img_dir = "$c->{htdocs_dir}/i/$f->{disk_id}";

   # Try to CHMOD first
   chmod 0777, $temp_dir;
   chmod 0777, $upload_dir;
   chmod 0777, $orig_dir;
   chmod 0777, $img_dir;

   # temp dir
   push @tests, -d $temp_dir ? 'temp dir exist: OK' : 'temp dir exist: ERROR';
   push @tests, mkdir("$temp_dir/test") ? 'temp dir mkdir: OK' : 'temp dir mkdir: ERROR';
   push @tests, rmdir("$temp_dir/test") ? 'temp dir rmdir: OK' : 'temp dir rmdir: ERROR';
   # upload dir
   push @tests, -d $upload_dir ? 'upload dir exist: OK' : 'upload dir exist: ERROR';
   push @tests, mkdir("$upload_dir/test") ? 'upload dir mkdir: OK' : 'upload dir mkdir: ERROR';
   push @tests, rmdir("$upload_dir/test") ? 'upload dir rmdir: OK' : 'upload dir rmdir: ERROR';
   # orig dir
   push @tests, -d $orig_dir ? 'orig dir exist: OK' : 'orig dir exist: ERROR';
   push @tests, mkdir("$orig_dir/test") ? 'orig dir mkdir: OK' : 'orig dir mkdir: ERROR';
   push @tests, rmdir("$orig_dir/test") ? 'orig dir rmdir: OK' : 'orig dir rmdir: ERROR';
   # htdocs dir
   push @tests, -d $img_dir ? 'img dir exist: OK' : 'img dir exist: ERROR';
   push @tests, mkdir("$img_dir/test") ? 'img dir mkdir: OK' : 'img dir mkdir: ERROR';
   push @tests, rmdir("$img_dir/test") ? 'img dir rmdir: OK' : 'img dir rmdir: ERROR';
   # XFSConfig.pm
   #push @tests, open(F,'XFSConfig.pm') ? 'config read: OK' : 'config read: ERROR';
   #push @tests, open(F,'>>XFSConfig.pm') ? 'config write: OK' : 'config write: ERROR';

   Send( "OK:".join('|',@tests) );
}

sub TestHost
{
   my @tests;

   # Try to CHMOD first
   chmod 0666, 'XFSConfig.pm';

   push @tests, -d "$c->{cgi_dir}/temp" ? 'temp dir exist: OK' : 'temp dir exist: ERROR';
   push @tests, -d "$c->{cgi_dir}/uploads" ? 'upload dir exist: OK' : 'upload dir exist: ERROR';
   push @tests, -d "$c->{htdocs_dir}/i" ? 'img dir exist: OK' : 'img dir exist: ERROR';
   push @tests, -d "$c->{cgi_dir}/orig" ? 'orig dir exist: OK' : 'orig dir exist: ERROR';

   # XFSConfig.pm
   push @tests, open(F,'XFSConfig.pm') ? 'config read: OK' : 'config read: ERROR';
   push @tests, open(F,'>>XFSConfig.pm') ? 'config write: OK' : 'config write: ERROR';

   my $site_cgi = $f->{site_cgi};
   my $ua = LWP::UserAgent->new(agent => $c->{user_agent},timeout => 90);
   my $res = postMain( {
                          op => 'test'
                       }
                      );
   push @tests, $res->content =~ /^OK/ ? 'fs.cgi: OK' : 'fs.cgi: ERROR '.$res->content;
   my ($ip) = $res->content =~ /^OK:(.*)/;

   if($f->{util_test})
   {
      my $x = `$c->{ffmpeg} 2>&1`;
      push @tests, $x=~/version/is ? 'ffmpeg: OK' : 'ffmpeg: ERROR';

      if($c->{mp4box_path})
      {
          my $mp4 = $c->{mp4box_path}||'MP4Box';
          my $x = `$mp4`;
          push @tests, $x=~/option/is ? 'MP4Box: OK' : 'MP4Box: ERROR';
      }

      my $x = `atop 1 1`;
      push @tests, $x=~/CPL/is ? 'atop: OK' : 'atop: ERROR';

      my $x = `iostat`;
      push @tests, $x=~/iowait/is ? 'iostat: OK' : 'iostat: ERROR';

      my $x = `convert`;
      push @tests, $x=~/ImageMagick/is ? 'ImageMagick convert: OK' : 'ImageMagick convert: ERROR';
   }
   
   Send( "OK:$ip:".join('|',@tests) );
}

sub UpdateConfig
{
   my $str = $f->{data};
   my $cc;
   for(split(/\~/,$str))
   {
      /^(.+?):(.*)$/;
      $cc->{$1}=$2;
   }

   my $conf;
   open(F,"$c->{cgi_dir}/XFSConfig.pm")||Send("Can't read Config");
   $conf.=$_ while <F>;
   close F;

   for my $x (keys %{$cc})
   {
      my $val = $cc->{$x};
      $conf=~s/$x\s*=>\s*(\S+)\s*,/"$x => '$val',"/e;
   }

   ### Test that we can write to HDD ###
   open(F,">$c->{cgi_dir}/temp/xfs.txt")||Send("Can't write to disk: disk is full?");
   print F "x\n" for 1..2002;
   close F;
   Send("Can't correctly write to disk: disk is full?") if -s "$c->{cgi_dir}/temp/xfs.txt" < 4000;
   unlink("$c->{cgi_dir}/temp/xfs.txt");
   #####################################

   open(F,">$c->{cgi_dir}/XFSConfig.pm")||Send("Can't write Config");
   print F $conf;
   close F;

   if($f->{restart_daemons})
   {
   		`killall -HUP enc.pl url_upload.pl transfer.pl`;
   }

   Send('OK');
}

sub TorrentDelete
{
   require TorrentClient;
   print "Content-type: text/html\n\n";
   print TorrentClient->new()->del_torrent(fs_key => $c->{host_id}, info_hash => $f->{sid});
   exit;
}

sub TorrentKill
{
   system("kill -9 `cat Torrents/torrent.pid`");
   print"Content-type:text/html\n\nOK";
   exit;
}

sub TorrentStatus
{
   require TorrentClient;
   print"Content-type:text/html\n\n";
   print eval { TorrentClient->new->get_status() } ? 'ON' : '';
   exit;
}

sub TorrentDone
{
   #my @files;
   my $sid = $1 if $f->{sid} =~ /^([a-z0-9]+)$/;
   die("No sid") if !$sid;
   require XUpload;
   XUpload::ImportDir("Torrents/workdir/$sid/", %$f);
   #rmtree("Torrents/workdir/$sid/");
   print "Content-type: text/html\n\nOK";
   exit;
}

sub Send
{
   my $txt = shift;
   print"Content-type:text/html\n\n";
   print $txt;
   exit;
}

sub randchar
{ 
   my @range = ('0'..'9','a'..'z');
   my $x = int scalar @range;
   join '', map $range[rand $x], 1..shift||1;
}

sub daemonize
{
    #chdir '/'                 or die "Can't chdir to /: $!";
    #close STDIN               or die "Can't close STDIN: $!";
    defined( my $pid = fork ) or die "Can't fork: $!";
    print("Content-type:text/html\n\nOK"),exit if $pid;
    #setsid                    or die "Can't start a new session: $!";
    close STDOUT              or die "Can't close STDOUT: $!";
    $SIG{CHLD} = 'IGNORE';
}

sub GenSnapshots
{
    my $snaps = $f->{m_s_samples};
    my $length = $f->{file_length};
    my $dt = $length / ($snaps-1);

    my $dx = sprintf("%05d",$f->{file_id}/$c->{files_per_folder});
    $f->{file_code} =~ s/\W+//g;
    $f->{disk_id} =~ s/\D+//g;
    $f->{create} =~ s/[^\d\.]+//g;
    
    my $file = "$c->{cgi_dir}/uploads/$f->{disk_id}/$dx/$f->{file_code}_h";
    $file     = "$c->{cgi_dir}/uploads/$f->{disk_id}/$dx/$f->{file_code}_n" unless -e $file;
    $file     = "$c->{cgi_dir}/orig/$f->{disk_id}/$dx/$f->{file_code}"      unless -e $file;
    $file     = "$c->{cgi_dir}/uploads/$f->{disk_id}/$dx/$f->{file_code}_l" unless -e $file;
    my $temp_dir = "$c->{htdocs_dir}/tmp/$f->{file_code}";
    mkdir($temp_dir);

    require XUpload;

    my @arr;

    if($f->{create})
    {
        my $idir = "$c->{htdocs_dir}/i/$f->{disk_id}/$dx";
        #`$c->{ffmpeg} -ss $f->{create} -i $file -vframes 1 -an -y -f image2 -vcodec mjpeg -qscale 3 $idir/$f->{file_code}.jpg`;
        XUpload::makeSnap($file, "$idir/$f->{file_code}.jpg", $f->{create});
        unlink("$idir/$f->{file_code}_t.jpg");
	    my $res = `convert $idir/$f->{file_code}.jpg -resize $c->{thumb_width}x$c->{thumb_height}^ -gravity center -extent $c->{thumb_width}x$c->{thumb_height} $idir/$f->{file_code}_t.jpg`;
        if($res=~/invalid/i)
        {
           `convert $idir/$f->{file_code}.jpg -resize $c->{thumb_width}x$c->{thumb_height} -gravity center $idir/$f->{file_code}_t.jpg`;
        }
        my $oldfiles = "$temp_dir/";
        unlink <$oldfiles*>;
        rmdir($temp_dir);
        Send("OK");
    }

    if($f->{preview})
    {
        my @tt = ($f->{preview}-1, $f->{preview}, $f->{preview}+1);
        my @arr;
        for my $t (@tt)
        {
            $t = sprintf("%.01f",$t);
            #`$c->{ffmpeg} -ss $t -i $file -vframes 1 -an -y -f image2 -vcodec mjpeg -vf scale=640:-1 -qscale 3 $temp_dir/$t.jpg`;
            XUpload::makeSnap($file, "$temp_dir/$t.jpg", $t, 640);
            push @arr, "$t";
        }
        Send( join("\n",@arr) );
    }

    for my $i (0..$snaps-1)
    {
        my $t = $i * $dt;
        $t = 3 if $i==0;
        $t = $length-3 if $i==$snaps-1;
        my $t = sprintf("%.01f",$t);
        #`$c->{ffmpeg} -ss $t -noaccurate_seek -i $file -vframes 1 -an -y -f image2 -vcodec mjpeg -vf scale=384:-1 $temp_dir/$t.jpg`;
        XUpload::makeSnap($file, "$temp_dir/$t.jpg", $t, 384, -1, 'fast');
        push @arr, "$t";
    }
    Send( join("\n",@arr) );
}

sub ReThumb
{
    for( split(/:/,$f->{list}) )
    {
        my ($disk_id,$file_id,$file_code,$file_length) = $_=~/^(\d+)-(\d+)-(\w+)-(\d+)$/;
        my $dx = sprintf("%05d",$file_id/$c->{files_per_folder});

        my $file = "$c->{cgi_dir}/uploads/$disk_id/$dx/$file_code\_h";
           $file = "$c->{cgi_dir}/uploads/$disk_id/$dx/$file_code\_n" unless -f $file;
           $file = "$c->{cgi_dir}/orig/$disk_id/$dx/$file_code"       unless -f $file;
           $file = "$c->{cgi_dir}/uploads/$disk_id/$dx/$file_code\_l" unless -f $file;
        return Send("OK") unless -f $file;   
        my $idir = "$c->{htdocs_dir}/i/$disk_id/$dx";
        #my $temp_dir = "$c->{cgi_dir}/temp";

        $c->{thumb_position} = sprintf("%.1f",$file_length*$1/100) if $c->{thumb_position}=~/^([\d\.]+)%$/;
        $c->{thumb_position}=5 unless $c->{thumb_position}=~/^[\d\.]+$/;
        $c->{thumb_position}=3 if $c->{thumb_position}<3;

        require XUpload;
        XUpload::makeSnap($file, "$idir/$file_code.jpg", $c->{thumb_position}, 0, 0);
        
        unlink("$idir/$file_code\_t.jpg");
        my $res = `convert $idir/$file_code.jpg -resize $c->{thumb_width}x$c->{thumb_height}^ -gravity center -extent $c->{thumb_width}x$c->{thumb_height} $idir/$file_code\_t.jpg`;
        if($res=~/invalid/i)
        {
           `convert $idir/$file_code.jpg -resize $c->{thumb_width}x$c->{thumb_height} $idir/$file_code\_t.jpg`;
        }
    }
    Send("OK");
}

sub ReScreen
{
    require XUpload;
    for( split(/:/,$f->{list}) )
    {
        my ($disk_id,$file_id,$file_code,$file_length,$file_name) = $_=~/^(\d+)-(\d+)-(\w+)-(\d+)-(.+)$/;
        my $dx = sprintf("%05d",$file_id/$c->{files_per_folder});

        my $file_path = "$c->{cgi_dir}/orig/$disk_id/$dx/$file_code";
           $file_path = "$c->{cgi_dir}/uploads/$disk_id/$dx/$file_code\_n" unless -f $file_path;
        my $idir = "$c->{htdocs_dir}/i/$disk_id/$dx";
        my $temp_dir = "$c->{cgi_dir}/temp/$disk_id/".randchar(5);
        mkdir($temp_dir) || Send("ERROR:mkdir $temp_dir:$!");
        chmod 0777, $temp_dir;

        my $file = { file_code => $file_code, file_length => $file_length, file_name_orig => $file_name };

        my $spec = XUpload::getVideoInfo($file_path,$f);

        XUpload::createScreenlist( $file_path, $file, $f, $temp_dir, $idir );

        rmdir($temp_dir);
    }
    Send("OK");
}

sub ReSlide
{
    require XUpload;
    for( split(/:/,$f->{list}) )
    {
        my ($disk_id,$file_id,$file_code,$file_length) = $_=~/^(\d+)-(\d+)-(\w+)-(\d+)$/;
        my $dx = sprintf("%05d",$file_id/$c->{files_per_folder});

        my $file_path = "$c->{cgi_dir}/orig/$disk_id/$dx/$file_code";
           $file_path = "$c->{cgi_dir}/uploads/$disk_id/$dx/$file_code\_n" unless -f $file_path;
        my $idir = "$c->{htdocs_dir}/i/$disk_id/$dx";
        my $temp_dir = "$c->{cgi_dir}/temp/$disk_id/".randchar(5);
        mkdir($temp_dir) || Send("ERROR:mkdir $temp_dir:$!");
        chmod 0777, $temp_dir;

        my $file = { file_code => $file_code, file_length => $file_length };

        #my $spec = XUpload::getVideoInfo($file_path,$f);

        XUpload::createTimeslides( $file_path, $file, $f, $temp_dir, $idir );

        rmdir($temp_dir);
    }
    Send("OK");
}

sub ReParse
{
    require XUpload;
    for( split(/:/,$f->{list}) )
    {
        my ($disk_id,$file_id,$file_code) = $_=~/^(\d+)-(\d+)-(\w+)$/;
        my $dx = sprintf("%05d",$file_id/$c->{files_per_folder});

        my $odir = "$c->{cgi_dir}/orig/$disk_id/$dx";
        my $udir = "$c->{cgi_dir}/uploads/$disk_id/$dx";
        my $idir = "$c->{htdocs_dir}/i/$disk_id/$dx";

        my ($data,$file_length);

        $data->{file_size_o} = -s "$odir/$file_code" || 0;
        $data->{file_spec_o} = $data->{file_size_o} ? XUpload::getVideoInfo("$odir/$file_code",$f) : '';
        $file_length ||= $f->{ID_LENGTH};

        $data->{file_size_n} = -s "$udir/$file_code\_n" || 0;
        $data->{file_spec_n} = $data->{file_size_n} ? XUpload::getVideoInfo("$udir/$file_code\_n",$f) : '';
        $file_length ||= $f->{ID_LENGTH};

        $data->{file_size_h} = -s "$udir/$file_code\_h" || 0;
        $data->{file_spec_h} = $data->{file_size_h} ? XUpload::getVideoInfo("$udir/$file_code\_h",$f) : '';
        $file_length ||= $f->{ID_LENGTH};

        $data->{file_size_l} = -s "$udir/$file_code\_l" || 0;
        $data->{file_spec_l} = $data->{file_size_l} ? XUpload::getVideoInfo("$udir/$file_code\_l",$f) : '';
        $file_length ||= $f->{ID_LENGTH};

        $data->{file_size_p} = -s "$udir/$file_code\_p" || 0;
        $data->{file_spec_p} = $data->{file_size_p} ? XUpload::getVideoInfo("$udir/$file_code\_p",$f) : '';
        $file_length ||= $f->{ID_LENGTH};

        my $res = postMain(
                        {
                           op 			=> 'update_file_data',
                           file_code  	=> $file_code,
                           file_length  => $file_length||0,
                           %$data,
                        }
                       );
    }

    Send("OK");
}

sub ThumbUpload
{
    die"Invalid input" unless $f->{disk_id}=~/^\d+$/ && $f->{file_code}=~/^\w{12}$/;
    my $dx = sprintf("%05d",$f->{file_id}/$c->{files_per_folder});
    my $dir = "$c->{htdocs_dir}/i/$f->{disk_id}/$dx";
    my $file = $q->tmpFileName( $q->param('file') );
    move($file,"$dir/$f->{file_code}.jpg");
    chmod 0666, "$dir/$f->{file_code}.jpg";
    `convert $dir/$f->{file_code}.jpg -resize $c->{thumb_width}x$c->{thumb_height}^ -gravity center -extent $c->{thumb_width}x$c->{thumb_height} $dir/$f->{file_code}_t.jpg`;
    chmod 0666, "$dir/$f->{file_code}_t.jpg";
    Send("OK");
}

sub PreviewUpload
{
    die"Invalid input" unless $f->{disk_id}=~/^\d+$/ && $f->{file_code}=~/^\w{12}$/;
    require Digest::MD5;
    my $md5 = Digest::MD5::md5_hex($f->{file_id}.$f->{file_code}.$c->{dl_key});
    Send("Error md5") unless $md5 eq $f->{md5};
    my $dx = sprintf("%05d",$f->{file_id}/$c->{files_per_folder});
    my $dir = "$c->{cgi_dir}/uploads/$f->{disk_id}/$dx";
    my $file = $q->tmpFileName( $q->param('file') );
    move($file,"$dir/$f->{file_code}_p");
    chmod 0666, "$dir/$f->{file_code}_p";
    my $sizep = -s "$dir/$f->{file_code}_p";

    my $ua = LWP::UserAgent->new(agent => $c->{user_agent},timeout => 360);
    my $res = postMain({
                           op     => 'update_file_data',
                           file_code  => $f->{file_code},
                           file_size_p  => $sizep,
                        }
                       );
    
    print $q->redirect(-uri => "$c->{site_url}/?op=file_edit&file_code=$f->{file_code}");
    exit;
}

sub GetVideoInfo
{
    $f->{file_code} =~ s/\W//g;
    $f->{disk_id} =~ s/\D//g;
    my $dx = sprintf("%05d",$f->{file_id}/$c->{files_per_folder});
    my $file = "$c->{cgi_dir}/uploads/$f->{disk_id}/$dx/$f->{file_code}_$f->{mode}";
    Send("File not found") unless -f $file;
    require XUpload;
    my $file_spec = XUpload::getVideoInfo($file,$f);
    Send("OK:$file_spec");
}

sub GetDevices
{
    my $out="DF:<br>";
    my $df=`df -BG -P`;
    for(split(/\n/,$df))
    {
      my ($dev,$total,$used,$free,$usedprc,$mount) = $_=~/^(.+?)\s+(\d+)G\s+(\d+)G\s+(\d+)G\s+(\d+%)\s+(.+)/gis;
      next unless $dev;
      next if $dev=~/^(tmpfs)$/i;
      $dev=~s/^\/dev\///;
      $dev=~s/^(.+)\/(.+)$/$2/;
      my $realtotal = $used+$free-1;
      $realtotal = 10*int($realtotal/10) if $realtotal>100;
      $out.=qq[<a href='#' onclick="\$('input[name=disk_dev_df]').val('$dev');return false;"><b>$dev</b></a> used: $used GB, free: <a href='#' onclick="\$('input[name=srv_disk_max]').val('$realtotal');return false;">$free</a> GB ($mount)<br>];
    }

    $out.="<br>IO:<br>";
    my $io=`iostat`;
    $io=~s/^.+Device://is;
    while($io=~/\n([\w\-]+)\s+/gis)
    {
      $out.=qq[<a href='#' onclick="\$('input[name=disk_dev_io]').val('$1');return false;"><b>$1</b></a><br>];
    }
    Send($out);
}

sub MoveMode
{
    my $dx = sprintf("%05d",$f->{file_id}/$c->{files_per_folder});
    die"Invalid input" unless $f->{disk_id}=~/^\d+$/ && $f->{file_code}=~/^\w{12}$/ && $f->{mode1}=~/^\w$/ && $f->{mode2}=~/^\w$/;
    my $orig = "$c->{cgi_dir}/orig/$f->{disk_id}/$dx/$f->{file_code}";
    my $file1 = $f->{mode1} eq 'o' ? $orig : "$c->{cgi_dir}/uploads/$f->{disk_id}/$dx/$f->{file_code}_$f->{mode1}";
    Send("File not found 1") unless -f $file1;

    my $file2 = $f->{mode2} eq 'o' ? $orig : "$c->{cgi_dir}/uploads/$f->{disk_id}/$dx/$f->{file_code}_$f->{mode2}";
    rename( $file1, $file2 ) || Send("Not able to rename file: $!");

    symlink( $file2, $orig ) if $f->{original} && !-e $orig;

    Send("OK");
}

sub SSDDelOld
{
   my $hh;
   die"Invalid input" unless $f->{disk_id}=~/^\d+$/;
   $hh->{$_}=1 for split(/\:/,$f->{list_ok});
   my $deleted=0;
   my $keep=0;
   $|++;
   print"Content-type:text/html\n\n";
   my $dir = "$c->{cgi_dir}/uploads/$f->{disk_id}";
   opendir(DIR, $dir) || Send("Error:cant open upload_dir");
   foreach my $fn (readdir(DIR))
   {
      next if $fn =~ /^\.{1,2}$/;
      next unless -d "$dir/$fn";
      next unless $fn=~/^\d{5}$/;
      opendir(DIR2, "$dir/$fn")||next;
      while( defined(my $fn2=readdir(DIR2)) )
      {
         next if $fn2 =~ /^\.{1,2}$/;
         my ($code) = $fn2=~/^(\w{12})_\w$/;
         next unless $code;
         unless($hh->{$code})
         {
          unlink("$dir/$fn/$fn2");
          $deleted++;
         }
         else
         {
           $keep++;
         }
      }
      closedir(DIR2);
   }
   closedir(DIR);
   print"Files removed from disk: $deleted, kept $keep";
}

sub GetHostInfo
{
	my $out;
	open FILE, "/proc/meminfo";
	my $mem = <FILE>;
	close FILE;
	my ($ram) = $mem=~/MemTotal:\s+(\d+) kB/;
	$ram = sprintf("%.1f", $ram/1024/1024 );
	$out="RAM: $ram GB";

	open FILE, "/proc/cpuinfo";
	my $cpu = join '', <FILE>;
	close FILE;
	my @arr = split /\n\n/, $cpu;
	$cpu=$arr[$#arr];
	my ($cpus) = $cpu=~/processor\s+: (\d+)/i;
	$cpus++;
	my ($model) = $cpu=~/model name\s+: (.+?)\n/i;
	$model=~s/\(R\)//g;
	$model=~s/\(TM\)//g;
	$out.="<br>CPU model: $model<br>CPU cores: $cpus";

	my $netfile = "/sys/class/net/eth0/speed";
	$netfile="/sys/class/net/bond0/speed" unless -f $netfile;
	$netfile="/sys/class/net/bond1/speed" unless -f $netfile;
	$netfile="/sys/class/net/eth1/speed" unless -f $netfile;
	if(-f $netfile)
	{
		open FILE, $netfile;
		my $net = <FILE>;
		close FILE;
		$out.="<br>Net speed: $net Mbps";
	}
	
	Send($out);
}

sub Streams
{
	print("Content-type:text/html\n\n"),exit unless $f->{call}=~/^(publish|publish_done|record_done|update_publish)$/; #|update_publish
	$f->{flashver}=$f->{pageurl}=$f->{swfurl}='';
	logg('streams',$f);	

	my $res = postMain({
                        op    	=> 'streams',
                        host_id => $c->{host_id},
                        call 	=> $f->{call},
                        app 	=> $f->{app},
                        name 	=> $f->{name},
                        addr 	=> $f->{addr},
                        time 	=> $f->{time},
                        key		=> $f->{key},
                       }
                      );
	unless($res->content=~/^OK/)
	{
		logg('streams', "fs error:".$res->content);
		print("Status: 404 Not found\n\n"),exit if $f->{call} eq 'publish';
	}
	print"Content-type:text/html\n\n";
	if($f->{call} eq 'record_done' && $f->{recorder}!~/preview/)
	{
		my (undef,$record)=split(/:/,$res->content);
		logg('streams', "rec:$record");
		if($record)
		{
			$f->{ip}=$f->{addr};
			$f->{fld_name}="Stream $f->{name}";
			#$f->{pub}=1;
			#ImportListDo();
			my ($fn) = $f->{path}=~/\/([^\/]+)$/;
			my $file = {file_tmp=>$f->{path}, file_name_orig=>$fn, file_public=>1, usr_id=>0, no_limits=>1};
			require XUpload;
      		$file = XUpload::ProcessFile($file,$f);
      		logg('streams', "process: $f->{path} : $fn : ".$file->{file_status});
			logg('streams', "done import.");
		}
		else
		{
			unlink($f->{path});
		}
	}
	exit;
}

sub postMain
{
	my ($data) = @_;
	$mua ||= LWP::UserAgent->new(agent => $c->{user_agent},timeout => 360);
	my $site_cgi = $c->{site_cgi} || $f->{site_cgi};
	return $mua->post("$site_cgi/fs.cgi",
	                  {
	                     dl_key => $c->{dl_key},
	                     %$data,
	                  }
	                 );
}

sub logg
{
	my ($type,$msg,$exit) = @_;
	return unless $type && $msg;
	if(ref $msg)
	{
		require Data::Dumper;
		$msg = Data::Dumper->Dump([$msg]);
	}
	open FILE, ">>logs/$type.txt" || return;
	print FILE $msg."\n";
	close FILE;
	print("Content-type:text/html\n\n$exit") if $exit && $exit ne 'exit';
	exit if $exit;
}